
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATtiny13
;Program type           : Application
;Clock frequency        : 1,200000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 16 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': No
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Automatic register allocation for global variables: On
;Smart register allocation: Off

	#define _MODEL_TINY_

	#pragma AVRPART ADMIN PART_NAME ATtiny13
	#pragma AVRPART MEMORY PROG_FLASH 1024
	#pragma AVRPART MEMORY EEPROM 64
	#pragma AVRPART MEMORY INT_SRAM SIZE 64
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x009F
	.EQU __DSTACK_SIZE=0x0010
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _mode=R3
	.DEF _maxmode=R4
	.DEF _currentStage=R5
	.DEF _maxStage=R6
	.DEF _timer=R7
	.DEF _timer_msb=R8
	.DEF _currentPeriod=R9
	.DEF _currentPeriod_msb=R10
	.DEF _maxPeriod=R11
	.DEF _maxPeriod_msb=R12
	.DEF _currentAngle=R13
	.DEF _Effect=R14

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_MAPA:
	.DB  0x6,0x5,0x38,0xA,0x1,0x0,0x1,0x5
	.DB  0x1,0xA,0x1,0xF,0x1,0xA,0x1,0x5
	.DB  0x19,0x1,0xB,0xA,0x1E,0xA,0x10,0xA
	.DB  0x1E,0xA,0x4,0x2,0x4,0xA,0x4,0x1E
	.DB  0x9,0x1E,0x9,0x5,0x6,0x0,0x6,0xA
_MAPM:
	.DB  0x6,0x5,0x38,0x8A,0x1,0x3,0x1,0x8F
	.DB  0x19,0x1,0x28,0x1,0xB,0xA,0x1E,0xA
	.DB  0x10,0xA,0x36,0x80,0x1E,0xA,0x4,0x2
	.DB  0x4,0xA,0x4,0x1E,0x9,0x1E,0x9,0x5
	.DB  0x6,0x0,0x6,0xA
_EFF:
	.DB  0x39,0x4,0x4D,0xB2,0x2,0x96,0x4,0xCF
	.DB  0x3F,0x2,0xC3,0x8,0xC0,0xC0,0x30,0x30
	.DB  0x10,0x0,0x49,0x69,0xC,0x3C,0x3C,0x3C
	.DB  0x3C,0x8,0x4C,0xDF,0xFF,0xA0,0x12,0xC0
	.DB  0xC0,0xC0,0x30,0x30,0x30,0xC3,0xC3,0xC3
	.DB  0x1A,0xC3,0xC3,0xC3,0xC3,0x0,0x0,0xFF
	.DB  0xFF,0xF0,0xF0,0xF0,0x0,0x0,0x1,0x0
	.DB  0xFA

_0x3:
	.DB  0x0,0x0,0x0,0x1E

__GLOBAL_INI_TBL:
	.DW  0x04
	.DW  _Angles
	.DW  _0x3*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x70

	.CSEG
;/**********************************************************************
; * tiny13_lights                                                      *
; *  ATtiny13   4-  . *
; *      Effects.c                  *
; **********************************************************************/
;
;//#define F_CPU 1200000UL
;#include <tiny13.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#define uint8_t unsigned char
;#define uint16_t unsigned int
;
;//
;#define EL0     PORTB0       //  0
;#define EL1     PORTB2       //  1
;//#define EL2     PORTB0       //  2
;//#define EL3     PORTB2       //  3
;#define BUTTON  PORTB5       // 
;#define ZC      PORTB1       //   (INT0)
;
;#define BUTTON_PRESSED    (!(PINB & (1 << BUTTON)))    //  
;
;uint8_t  mode;               //  
;uint8_t  maxmode;            //   
;uint8_t  currentStage;       //   
;uint8_t  maxStage;           //   
;uint16_t timer;              //    
;uint16_t currentPeriod;      //    
;uint16_t maxPeriod;          //        
;uint8_t  currentAngle;       //    ( 0  maxAngle)
;#define  minAngle      Angles[3]     //        
;#define  risingAngle   Angles[2]     //     
;#define  fallingAngle  Angles[1]     //     
;#define  maxAngle      Angles[0]     //        
;uint8_t  angle[2];                   //    1-4 
;#define  Flags         ADMUX                // ,      
;//#define  Flag2         ADCSRB        //ADCSRA       //DWDR
;//#define  INVERT i&0x80
;#define  DIR1   i&0x40
;#define  DIR0   i&0x20
;#define  _I     0b10000000
;#define  _F     0b01100000
;#define  _B     0b01000000
;#define  _S     0b00100000
;#define  _R     0b00000000
;
;#define  AUTOB  Flags.6              // 
;#define  DIR    Flags.5              //   
;#define  SINHRO Flags.1              // 
;#define  INVERT Flags.0
;uint8_t  Effect;
;
;//#define halfAngle minAngle+STEPS/2
;#include <Effects.c>
;//Settings
;#define PWM_ENABLED           0      //   (  -   ,  )
;//PWM_ENABLED    = 0;     = 1;      ...
;#define FILTER                20     //      (    - )
;#define AUTOBUTTON            40     //     
;#define Otstup1               30     //    (   - ,   ...
;//Otstup1:   .  30,   .  10,   PWM - 0
;#define Otstup2               1      //    (   - ,   ...
;//Otstup2:   .  10,   .  3,   PWM - 0
;#define STEPS                 100    // {48-250}    (- ,     ...
;#define SLEEP                 0      //   :(
;
;//Effects
;
;//NAME OF PATTERNS
;// ,      
;#define ALLINCLUSIV 0,  //  
;#define VOLNA       1,  //  
;#define KASHKA      4,  //  
;#define TWOSTEP     6,  // 1,5 
;#define STEP        9,  // 1 
;#define STEP2       11, // 2 
;#define PEREBEG     16, //   2 
;#define KASKADUP    25, //  
;#define KASKAD2     30, //  ,    
;//#define DOLGIY      40, //2   
;#define MIGMIG      40, //2   2  
;//#define NABEG       76, //2   2  
;#define ALL_OFF     54, // 
;#define RANDOM      56, // 
;
;//  :    (  ),  (0-31   -  ) //
;//-------------------------------------------------------------------------------------------------------//
;//  ,    (    )
;//:
;//_I -   <->
;//_F -    
;//_B -      
;//_S -    (    )
;//_R -    (    )(  PWM     ...
;
;//    
;const uint8_t MAPA[] =
;              {
;              TWOSTEP  5,
;              RANDOM   10,
;              VOLNA    0,
;              VOLNA    5,
;              VOLNA    10,
;              VOLNA    15,
;              VOLNA    10,
;              VOLNA    5,
;              KASKADUP 1,
;              STEP2    10,
;              KASKAD2  10,
;              PEREBEG  10,
;              KASKAD2  10,
;              KASHKA   2,
;              KASHKA   10,
;              KASHKA   30,
;              STEP     30,
;              STEP     5,
;              TWOSTEP  0,
;              TWOSTEP  10,
;              };
;
;//    
;const uint8_t MAPM[] =
;              {
;              TWOSTEP  5,
;              RANDOM   _I|10,
;              //NABEG    _F|10,
;              //DOLGIY   10,
;              VOLNA    3,
;              VOLNA    _I|15,
;              KASKADUP 1,
;              MIGMIG   1,
;              STEP2    10,
;              KASKAD2  10,
;              PEREBEG  10,
;              ALL_OFF  _I|0,
;              KASKAD2  10,
;              KASHKA   2,
;              KASHKA   10,
;              KASHKA   30,
;              STEP     30,
;              STEP     5,
;              TWOSTEP  0,
;              TWOSTEP  10,
;              };
;
;//PATTERNS  (  )
;//-   ,  .....
;// : =4  .
;//: 00 -  , 01 - , 11 - , 10 - 
;const uint8_t EFF[] =
;      {57,         // 0b 11 10 00 01       = 1 , 2 , 3  , 4  //ALLINCLUSIV  1 ( ...
;        4,0b01001101,0b10110010,                                                                   //1  VOLNA
;        2,0b10010110,                                                                              //4  KASHKA
;        4,0b11001111,0b00111111,                                                                   //6  TWOSTEP
;        2,0b11000011,                                                                              //9 STEP
;        8,0b11000000,0b11000000,0b00110000,0b00110000,                                             //11 STEP2
;       16,0b00000000,0b01001001,0b01101001,0b00001100,0b00111100,0b00111100,0b00111100,0b00111100, //16 PEREBEG
;        8,0b01001100,0b11011111,0b11111111,0b10100000,                                             //25 KASKADUP
;       18,0b11000000,0b11000000,0b11000000,0b00110000,0b00110000,0b00110000,0b11000011,0b11000011,0b11000011,//30 KASKAD ...
;       26,0b11000011,0b11000011,0b11000011,0b11000011,0b00000000,0b00000000,0b11111111,0b11111111, //40 MIGMIG
;          0b11110000,0b11110000,0b11110000,0b00000000,0b00000000,
;        1,0b00000000,                                                                              //54 ALL_OFF
;      250};                                                                                        //56 - RANDOM
;//  =   ,            ...
;uint8_t  Angles[4]={0,0,0,Otstup1};

	.DSEG
;#if PWM_ENABLED==2
;#define  DEFPORT       ~((0<<ZC)|(1<<EL0)|(1<<EL1))
;#else
;#define  DEFPORT       ~((1<<ZC)|(1<<EL0)|(1<<EL1))
;#endif
;
;void main(void)
; 0000 003F {// Reset Source checking

	.CSEG
_main:
; .FSTART _main
; 0000 0040 uint8_t i;
; 0000 0041 uint8_t tmp;
; 0000 0042 if (MCUSR & (1<<EXTRF))
;	i -> R16
;	tmp -> R17
	IN   R30,0x34
	SBRS R30,1
	RJMP _0x4
; 0000 0043     {
; 0000 0044     // External Reset
; 0000 0045     maxmode=(sizeof(MAPM))&0xFE;
	LDI  R30,LOW(36)
	MOV  R4,R30
; 0000 0046     mode++;
	INC  R3
; 0000 0047     if(AUTOB) mode=maxmode;
	SBIC 0x7,6
	MOV  R3,R4
; 0000 0048     AUTOB=0;
	CBI  0x7,6
; 0000 0049     }
; 0000 004A if ((MCUSR & ((1<<PORF)|(1<<BORF)))||(timer<=(70)))
_0x4:
	IN   R30,0x34
	ANDI R30,LOW(0x5)
	BRNE _0x9
	LDI  R30,LOW(70)
	LDI  R31,HIGH(70)
	CP   R30,R7
	CPC  R31,R8
	BRLO _0x8
_0x9:
; 0000 004B     {
; 0000 004C     // Power-on Reset  // Brown-Out Reset // DoubleClick
; 0000 004D     maxmode=(sizeof(MAPA))&0xFE;
	LDI  R30,LOW(40)
	MOV  R4,R30
; 0000 004E     AUTOB=1;
	SBI  0x7,6
; 0000 004F     mode=maxmode;
	MOV  R3,R4
; 0000 0050     }
; 0000 0051     //SINHRO=0;
; 0000 0052     MCUSR=0;
_0x8:
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 0053 
; 0000 0054 
; 0000 0055     // Crystal Oscillator division factor: 4
; 0000 0056 #pragma optsize-
; 0000 0057     CLKPR=(1<<CLKPCE);
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 0058     CLKPR=(0<<CLKPCE) | (2<<CLKPS0);
	LDI  R30,LOW(2)
	OUT  0x26,R30
; 0000 0059 #ifdef _OPTIMIZE_SIZE_
; 0000 005A #pragma optsize+
; 0000 005B #endif
; 0000 005C 
; 0000 005D     //   /:
; 0000 005E     DDRB  = (1<<EL0)|(1<<EL1);
	LDI  R30,LOW(5)
	OUT  0x17,R30
; 0000 005F     PORTB = DEFPORT; //    PB5
	LDI  R30,LOW(248)
	OUT  0x18,R30
; 0000 0060 
; 0000 0061     //   :
; 0000 0062 #if (PWM_ENABLED==2)
; 0000 0063     GIMSK=(0<<INT0) | (0<<PCIE);        //    .
; 0000 0064 #else
; 0000 0065     //GIFR = (1<<INTF0) | (0<<PCIF);
; 0000 0066     GIMSK= (1<<INT0)  | (0<<PCIE);        //    INT0.
	LDI  R30,LOW(64)
	OUT  0x3B,R30
; 0000 0067 #endif
; 0000 0068     MCUCR = 0b00100001;        //    INT0    (   )
	LDI  R30,LOW(33)
	OUT  0x35,R30
; 0000 0069 
; 0000 006A     //   T0   10 (F=1200000/120=10000, =1/10000=100):
; 0000 006B     TCCR0A    = 0b00000010;    //  CTC (    OCR0A)
	LDI  R30,LOW(2)
	OUT  0x2F,R30
; 0000 006C     TCCR0B    = 0b00000010;    //    
	OUT  0x33,R30
; 0000 006D     OCR0A     = (3000/(STEPS+Otstup2+Otstup1))-1; //119;           //    A     ...
	LDI  R30,LOW(21)
	OUT  0x36,R30
; 0000 006E     TIMSK0    = 0b00000100;    //       OCR0A
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 006F 
; 0000 0070     #asm("sei") //  
	sei
; 0000 0071 
; 0000 0072     //  
; 0000 0073     while(1)
_0xD:
; 0000 0074     {
; 0000 0075     #if SLEEP
; 0000 0076     #asm("sleep")
; 0000 0077     #else
; 0000 0078     while(SINHRO){};
_0x10:
	SBIC 0x7,1
	RJMP _0x10
; 0000 0079     SINHRO=1;
	SBI  0x7,1
; 0000 007A     #endif
; 0000 007B 
; 0000 007C 
; 0000 007D if (mode&0x01)
	SBRS R3,0
	RJMP _0x15
; 0000 007E     { //  
; 0000 007F     tmp =  EFF[Effect+(currentStage>>1)];
	MOV  R30,R5
	LSR  R30
	ADD  R30,R14
	LDI  R31,0
	SUBI R30,LOW(-_EFF*2)
	SBCI R31,HIGH(-_EFF*2)
	LPM
	MOV  R17,R0
; 0000 0080     if (INVERT) tmp=~tmp;
	SBIC 0x7,0
	COM  R17
; 0000 0081     if ((currentStage&1)==0) tmp>>=4;
	SBRC R5,0
	RJMP _0x17
	SWAP R17
	ANDI R17,0xF
; 0000 0082     angle[0] = Angles[tmp&3];
_0x17:
	RCALL SUBOPT_0x0
	STS  _angle,R30
; 0000 0083     tmp>>=2;
	LSR  R17
	LSR  R17
; 0000 0084     angle[1] = Angles[tmp&3];
	RCALL SUBOPT_0x0
	__PUTB1MN _angle,1
; 0000 0085 
; 0000 0086     timer++;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 7,8,30,31
; 0000 0087     if ((AUTOB)&(timer>(AUTOBUTTON*100))) mode++;   // 
	LDI  R30,0
	SBIC 0x7,6
	LDI  R30,1
	MOV  R0,R30
	__GETW2R 7,8
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL __GTW12U
	AND  R30,R0
	BREQ _0x18
	INC  R3
; 0000 0088     }
_0x18:
; 0000 0089 else
	RJMP _0x19
_0x15:
; 0000 008A     { // 
; 0000 008B     mode++;
	INC  R3
; 0000 008C     currentPeriod = 0;    //..
	CLR  R9
	CLR  R10
; 0000 008D     currentStage = 2;
	LDI  R30,LOW(2)
	MOV  R5,R30
; 0000 008E     if (mode>maxmode) mode=1;
	CP   R4,R3
	BRSH _0x1A
	LDI  R30,LOW(1)
	MOV  R3,R30
; 0000 008F     if (AUTOB)
_0x1A:
	SBIS 0x7,6
	RJMP _0x1B
; 0000 0090         {
; 0000 0091         i = MAPA[mode];
	MOV  R30,R3
	LDI  R31,0
	SUBI R30,LOW(-_MAPA*2)
	SBCI R31,HIGH(-_MAPA*2)
	RCALL SUBOPT_0x1
; 0000 0092         Effect = MAPA[mode-1];
	SUBI R30,LOW(-_MAPA*2)
	SBCI R31,HIGH(-_MAPA*2)
	RJMP _0x47
; 0000 0093         }
; 0000 0094     else
_0x1B:
; 0000 0095         {
; 0000 0096         i = MAPM[mode];
	MOV  R30,R3
	LDI  R31,0
	SUBI R30,LOW(-_MAPM*2)
	SBCI R31,HIGH(-_MAPM*2)
	RCALL SUBOPT_0x1
; 0000 0097         Effect = MAPM[mode-1];
	SUBI R30,LOW(-_MAPM*2)
	SBCI R31,HIGH(-_MAPM*2)
_0x47:
	LPM
	MOV  R14,R0
; 0000 0098         };
; 0000 0099     maxStage  = EFF[Effect];;
	MOV  R30,R14
	LDI  R31,0
	SUBI R30,LOW(-_EFF*2)
	SBCI R31,HIGH(-_EFF*2)
	LPM
	MOV  R6,R0
; 0000 009A 
; 0000 009B     INVERT=0;
	CBI  0x7,0
; 0000 009C     if (i&0x80) INVERT=1;
	SBRC R16,7
	SBI  0x7,0
; 0000 009D     if (DIR1)
	SBRS R16,6
	RJMP _0x22
; 0000 009E         {
; 0000 009F         if (DIR0) DIR=0;                             //  
	SBRC R16,5
	CBI  0x7,5
; 0000 00A0         }
; 0000 00A1     else
	RJMP _0x26
_0x22:
; 0000 00A2         {
; 0000 00A3         if (DIR0) {if(DIR) DIR=0; else DIR=1;}       // 
	SBRS R16,5
	RJMP _0x27
	SBIS 0x7,5
	RJMP _0x28
	CBI  0x7,5
	RJMP _0x2B
_0x28:
	SBI  0x7,5
_0x2B:
; 0000 00A4         #if (PWM_ENABLED==2)
; 0000 00A5         else      {if(timer&1) DIR=1; else DIR=0;};  //  
; 0000 00A6         #else
; 0000 00A7         else      {if(TCNT0&1) DIR=1; else DIR=0;};  //  
	RJMP _0x2E
_0x27:
	IN   R30,0x32
	SBRS R30,0
	RJMP _0x2F
	SBI  0x7,5
	RJMP _0x32
_0x2F:
	CBI  0x7,5
_0x32:
_0x2E:
; 0000 00A8         #endif
; 0000 00A9         };
_0x26:
; 0000 00AA     timer=0;
	CLR  R7
	CLR  R8
; 0000 00AB 
; 0000 00AC     i&=0x1F;   // 
	ANDI R16,LOW(31)
; 0000 00AD     #pragma warn-
; 0000 00AE     maxPeriod=((char)i&3)+4;
	MOV  R30,R16
	ANDI R30,LOW(0x3)
	SUBI R30,-LOW(4)
	MOV  R11,R30
	CLR  R12
; 0000 00AF     #pragma warn+
; 0000 00B0     i>>=2;
	LSR  R16
	LSR  R16
; 0000 00B1     maxPeriod<<=i;
	MOV  R30,R16
	__GETW2R 11,12
	RCALL __LSLW12
	__PUTW1R 11,12
; 0000 00B2     };
_0x19:
; 0000 00B3 }
	RJMP _0xD
; 0000 00B4 }
_0x35:
	RJMP _0x35
; .FEND
;
;//  
;#if (PWM_ENABLED==2)
;void in_sinhro (void){
;#else
;interrupt [EXT_INT0] void ext_int0_isr(void){
; 0000 00BA interrupt [2] void ext_int0_isr(void){
_ext_int0_isr:
; .FSTART _ext_int0_isr
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 00BB #endif
; 0000 00BC // #asm("wdr")
; 0000 00BD #if PWM_ENABLED
; 0000 00BE PORTB = DEFPORT; //    
; 0000 00BF #endif
; 0000 00C0 maxAngle = currentAngle - Otstup2; //         
	MOV  R30,R13
	SUBI R30,LOW(1)
	STS  _Angles,R30
; 0000 00C1 currentAngle = 0; //   
	CLR  R13
; 0000 00C2 #if (PWM_ENABLED<2)
; 0000 00C3 GIMSK=(0<<INT0) | (0<<PCIE);
	LDI  R30,LOW(0)
	OUT  0x3B,R30
; 0000 00C4 #endif
; 0000 00C5 SINHRO=0;
	CBI  0x7,1
; 0000 00C6 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
; .FEND
;
;// 
;interrupt [TIM0_COMPA] void timer0_compa_isr(void){
; 0000 00C9 interrupt [7] void timer0_compa_isr(void){
_timer0_compa_isr:
; .FSTART _timer0_compa_isr
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00CA #if !PWM_ENABLED
; 0000 00CB     PORTB = DEFPORT; //     
	LDI  R30,LOW(248)
	OUT  0x18,R30
; 0000 00CC #endif
; 0000 00CD 
; 0000 00CE if ( currentAngle == angle[0]) { if (DIR) PORTB |= (1 << EL0); else PORTB |= (1<<EL1); }; //   (  ...
	LDS  R30,_angle
	CP   R30,R13
	BRNE _0x38
	SBIS 0x7,5
	RJMP _0x39
	SBI  0x18,0
	RJMP _0x3A
_0x39:
	SBI  0x18,2
_0x3A:
_0x38:
; 0000 00CF if ( currentAngle == angle[1]) { if (DIR) PORTB |= (1 << EL1); else PORTB |= (1<<EL0); }; //   (  ...
	__GETB1MN _angle,1
	CP   R30,R13
	BRNE _0x3B
	SBIS 0x7,5
	RJMP _0x3C
	SBI  0x18,2
	RJMP _0x3D
_0x3C:
	SBI  0x18,0
_0x3D:
_0x3B:
; 0000 00D0 
; 0000 00D1 if (~currentAngle) currentAngle++; else GIMSK = (1<<INT0) | (0<<PCIE); //   
	MOV  R30,R13
	COM  R30
	CPI  R30,0
	BREQ _0x3E
	INC  R13
	RJMP _0x3F
_0x3E:
	LDI  R30,LOW(64)
	OUT  0x3B,R30
; 0000 00D2 
; 0000 00D3 //    :
; 0000 00D4 if ( currentPeriod < maxPeriod )     //  
_0x3F:
	__CPWRR 9,10,11,12
	BRSH _0x40
; 0000 00D5     currentPeriod++;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 9,10,30,31
; 0000 00D6 else
	RJMP _0x41
_0x40:
; 0000 00D7     {currentPeriod = 0; //   
	CLR  R9
	CLR  R10
; 0000 00D8 
; 0000 00D9     if ( risingAngle < maxAngle )
	RCALL SUBOPT_0x2
	CP   R26,R30
	BRSH _0x42
; 0000 00DA         {
; 0000 00DB         risingAngle++; //   
	__GETB1MN _Angles,2
	SUBI R30,-LOW(1)
	__PUTB1MN _Angles,2
; 0000 00DC         }
; 0000 00DD         else
	RJMP _0x43
_0x42:
; 0000 00DE         {
; 0000 00DF         risingAngle = minAngle; //   
	__GETB1MN _Angles,3
	__PUTB1MN _Angles,2
; 0000 00E0 
; 0000 00E1         if ( currentStage <= maxStage ) currentStage++; //     
	CP   R6,R5
	BRLO _0x44
	INC  R5
; 0000 00E2             else                       currentStage=2; //     (  )
	RJMP _0x45
_0x44:
	LDI  R30,LOW(2)
	MOV  R5,R30
; 0000 00E3 		}
_0x45:
_0x43:
; 0000 00E4 	fallingAngle = maxAngle - risingAngle + minAngle;  //   
	RCALL SUBOPT_0x2
	SUB  R30,R26
	MOV  R26,R30
	__GETB1MN _Angles,3
	ADD  R30,R26
	__PUTB1MN _Angles,1
; 0000 00E5 	}
_0x41:
; 0000 00E6 
; 0000 00E7 #if (PWM_ENABLED==2)
; 0000 00E8 if (currentAngle==(STEPS+Otstup2+Otstup1))  in_sinhro();
; 0000 00E9 #else
; 0000 00EA if (currentAngle==(STEPS+Otstup2+Otstup1-FILTER))
	LDI  R30,LOW(111)
	CP   R30,R13
	BRNE _0x46
; 0000 00EB     {
; 0000 00EC     GIFR = (1<<INTF0) | (0<<PCIF);
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 00ED     GIMSK = (1<<INT0) | (0<<PCIE);    //    INT0,
	OUT  0x3B,R30
; 0000 00EE     }
; 0000 00EF #endif
; 0000 00F0 }
_0x46:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
; .FEND

	.DSEG
_angle:
	.BYTE 0x2
_Angles:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	MOV  R30,R17
	ANDI R30,LOW(0x3)
	SUBI R30,-LOW(_Angles)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	LPM
	MOV  R16,R0
	MOV  R30,R3
	SUBI R30,LOW(1)
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	__GETB2MN _Angles,2
	LDS  R30,_Angles
	RET


	.CSEG
__LSLW12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	MOV  R31,R27
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__GTW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLO __GTW12UT
	CLR  R30
__GTW12UT:
	RET

;END OF CODE MARKER
__END_OF_CODE:
